routes/web.php
<?php

use App\Http\Controllers\web\LanguageController;
use App\Http\Controllers\web\ContactController;
use App\Http\Controllers\web\DarkThemeController;
use App\Http\Controllers\web\CommentController;
use App\Http\Controllers\web\OrderController;
use App\Http\Controllers\web\ProductController;
use App\Http\Controllers\web\UserController;
use Illuminate\Support\Facades\Route;
use \App\Http\Controllers\web\CategoryController;
use \App\Http\Controllers\web\CartController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::view('/', 'static_sites.start')->name('start_view');
Route::post('/contact', ContactController::class)->name('web.contact_form');
Route::view('/contact', 'static_sites.contact')->name('contact_view');

Route::redirect('products/comments', '/products/comments/start');
Route::resource('products', ProductController::class, ['as' => 'web', 'except' => '']);
//Route::resource('products', ProductController::class);
Route::resource('products.comments', CommentController::class, ['as' => 'web', ]);
Route::get('products/comments/start', [CommentController::class, 'start'])->name('web.products.start');
Route::get('products/{slug}', [ProductController::class, 'show'])->name('web.products.show');

Route::group([
    // 'prefix' => 'pl', //  do geta
    'as' => 'web.',
    'middleware' => [
        // 'verified',
        // 'auth',
        // 'userLogs'
    ],
    ], function() {
        Route::get('categories/', [CategoryController::class, 'index'])->name('categories.index');
        // Route::get('categories/{category}', [CategoryController::class, 'show'])->name('categories.show');
        Route::get('categories/{slug}', [CategoryController::class, 'show'])->name('categories.show');

        // Route::get('users', [UserController::class, 'index'])->name('users.index');
        // Route::get('users/{user}', [UserController::class, 'edit'])->name('users.edit');
        // Route::delete('users/{user}', [UserController::class, 'destroy'])->name('user.delete');
        Route::resource('users', UserController::class)->only(['index', 'edit', 'update', 'destroy']);

        Route::get('cart/index', [CartController::class, 'index'])->name('cart.index');
        Route::post('cart/{product}/{goBackWithMessage?}', [CartController::class, 'store'])->name('cart.store');
        Route::delete('cart/{product}', [CartController::class, 'destroy'])->name('cart.destroy');

        Route::get('orders', [OrderController::class, 'index'])->name('orders.index');
        Route::post('orders', [OrderController::class, 'store'])->name('orders.store');
        Route::get('orders/{order}', [OrderController::class, 'show'])->name('orders.show');
    }
);

Route::get('/dark-theme', DarkThemeController::class)->name('web.dark_theme');
Route::get('lang/{lang}', [LanguageController::class, 'switchLang'])->name('web.lang_switch');

app/Http/Controllers/api/v1/CartController.php
<?php

namespace App\Http\Controllers\api\v1;

use App\Http\Controllers\Controller;
use App\Http\Resources\CartResource;
use App\valueObjects\Cart;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;

class CartController extends Controller
{
    public function index(): JsonResponse
    {
        $cart = Session::get('cart', new Cart());
        return response()->json($cart, 200);
        // return CartResource::collection($cart);
    }
}

app/Http/Controllers/web/CartController.php
<?php

declare(strict_types=1);

namespace App\Http\Controllers\web;

use App\valueObjects\Cart;
use App\valueObjects\CartItem;
use App\Http\Controllers\Controller;
use App\Models\Product;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Arr;
use Illuminate\Support\Facades\Session;
use Illuminate\View\View;

/**
 * Czy może w sesji przechowywać tylko IDiki produktów,
 * a w koszyku odptać DB o te produkty?
 */
class CartController extends Controller
{
    public function index(): View
    {
        $cart = Session::get('cart', new Cart());
        return view('cart.index', compact('cart'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    public function store(Product $product, bool $goBackWithMessage = null): RedirectResponse
    {
        $cart = Session::get('cart', new Cart());
        Session::put('cart', $cart->addItem($product));

        if($goBackWithMessage == true) {
            return redirect()->back()->with('success', 'Dodano element do koszyka.');
        }
        return redirect()->route('web.cart.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  int                      $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    public function destroy(Product $product): RedirectResponse
    {
        try{
            $cart = Session::get('cart', new Cart());
            Session::put('cart', $cart->removeItem($product));
            return redirect()->back()->with('success', 'Rekord usunięto');
        } catch (\Exception $e)
        {
            return redirect()->back()->with('error', 'Wystąpił błąd, nie można usunąć pozycjiusunięto');
        }
    }

    private function incrementQuantity()
    {
        $this->quantity += 1;
    }
}

resources/views/cart/index.blade.php
{{--https://bbbootstrap.com/snippets/ecommerce-shopping-cart-30657531--}}

@extends('layout.my_monolit')

@section('title', 'Products')

@section('css-files')
    <link rel="stylesheet" href="{{ asset('css/cart.css') }}">
@endsection

@section('main')
    @include('layout.my_monolit.site_elements.flash_message')
    <section id="cart">
        <div class="card pt-5 mb-4">
            <div class="card-body">
                <div class="mb-5">
                    <h1 class="display-1 text-center">Shopping Cart</h1>
                    <p class="lead text-center">Let's start shopping</p>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col">
                <form action="{{ route('web.orders.store') }}" method="POST">
                    @csrf
                    @method('POST')
                <div class="cart_container">
                    <div class="cart_title d-flex justify-content-between">
                        <span>Shopping Cart</span>
                        <span class="small text-muted font-weight-light">| {{ $cart->getItems()->count() }} product @if($cart->getItems()->count() > 1)s @endif in your cart</span>
                    </div>
{{--                    <div>@include('layout.my_monolit.site_elements.flash_message')</div>--}}
                    <div class="cart_items">
                        <ul class="cart_list">
                            @forelse($cart->getItems() as $item)
                                <li class="cart_item clearfix mb-1 bg-light">
                                    <div class="cart_item_image"><img src="https://i.imgur.com/qqBRWD5.jpg" alt=""></div>
                                    <div class="cart_item_info d-flex flex-md-row flex-column justify-content-between">
                                        <div class="cart_item_name cart_info_col">
                                            <div class="cart_item_title">Name</div>
                                            <div class="cart_item_text"><a href="{{ route('web.products.show', ['slug' => 1]) }}">{{ $item->getName() }}</a></div>
                                        </div>
                                        <div class="cart_item_color cart_info_col">
                                            <div class="cart_item_title">Color</div>
                                            <div class="cart_item_text small"><span style="background-color:#999999;"></span>Silver</div>
                                        </div>
                                        <div class="cart_item_quantity cart_info_col">
                                            <div class="cart_item_title">Quantity</div>
                                            <div class="cart_item_text">{{ $item->getQuantity() }}</div>
                                        </div>
                                        <div class="cart_item_price cart_info_col">
                                            <div class="cart_item_title">Price</div>
                                            <div class="cart_item_text">{{ $item->getPrice() }} </div>
                                        </div>
                                        <div class="cart_item_total cart_info_col">
                                            <div class="cart_item_title">Total</div>
                                            <div class="cart_item_text">{{ $item->getSum() }} {{ __('shop.price.shortcut') }}</div>
                                        </div>
                                        <div class="cart_item_total cart_info_col">
                                            <div class="cart_item_title">&nbsp;</div>
                                            <div class="cart_item_text small">
{{--                                                <form class="d-inline-block" action="{{ route('web.cart.destroy', ['product' => $item->getProductId() ]) }}" method="post">--}}
{{--                                                    @csrf--}}
{{--                                                    @method('DELETE')--}}
{{--                                                    <button type="submit" class="btn btn-sm btn-outline-danger"><i class="far fa-trash-alt"></i></button>--}}
{{--                                                </form>--}}
{{--                                                <form class="d-inline-block" action="{{ route('web.cart.store', ['product' => $item->getProductId(), 'goBackWithMessage' => true ]) }}" method="post">--}}
{{--                                                    @csrf--}}
{{--                                                    @method('POST')--}}
{{--                                                    <button type="submit" class="btn btn-sm btn-outline-info"><i class="fas fa-plus small"></i></button>--}}
{{--                                                </form>--}}
                                                <a href="" class="btn btn-sm btn-outline-warning"><i class="fas fa-minus"></i></a>
                                            </div>
                                        </div>

                                    </div>
                                </li>
                            @empty
                                <li class="cart_item clearfix pb-0 ">
                                    <div class="alert alert-info text-center lead" role="alert">Empty!</div>
                                </li>
                            @endforelse
                        </ul>
                    </div>
                    <div class="order_total">
                        <div class="order_total_content d-flex justify-content-between">
                            <div class="order_total_title">
                                {{ __('shop.order.total') }}:</div>
                            <div class="order_total_amount">{{ $cart->getSum() }} {{ __('shop.price.shortcut') }}</div>
                        </div>
                    </div>
                    <div class="cart_buttons">
                        <a href="{{ route('web.products.index') }}" class="button cart_button_clear">Continue Shopping</a>
                        @if($cart->hasItems())
                            <input type="submit" class="btn btn-lg btn-outline-info rounded-0" value="Pay">
                        @endif
                        <a href="{{ url()->previous() }}" class="btn btn-lg btn-outline-dark rounded-0">Back</a>
                    </div>
                </div>
                </form>
            </div>
        </div>
    </section>
@endsection